import com.IBM.WirelessClient.API.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import java.awt.event.*;

public class TryWindow extends JFrame implements eWirelessAPIListener, WindowListener, ActionListener
{

    protected String rcStrings[] = 
     { "eOK",
     "eOperationPending",
     "eErrFailed",
     "eErrMemoryFailure",
     "eErrInvalidParameter",
     "eErrQueueAlreadyRegistered",
     "eErrForcePasswordChange",
     "eErrCoreNotStarted",
     "eErrNotInitialized",
     "eErrNotSupported",
     "eErrModemInitFailed",
     "eErrCommPort",
     "eErrTooManyInterfaces",
     "eErrInvalidConfiguration",
     "eErrBadState",
     "eErrNdisNotConfigured",
     "eErrNoActiveInterface",
     "eErrTimeout",
     "eErrPassword",
     "eErrProtocol",
     "eErrAuthorizationRequired",
     "eErrGatewayDown",
     "eErrAccountDeleted",
     "eErrAccountUnknown",
     "eErrAlreadyConnected",
     "eErrOperator",
     "eErrVersion",
     "eErrAccountLocked",
     "eErrAccountExpired",
     "eErrInvalidNewPassword",
     "eErrInitUnknown",
     "eErrModemConnectFailed",
     "eErrAddressNotAvailable",
     "eErrAddressInUse",
     "eErrDestinationInvalid",
     "eErrBufferTooSmall"};



    protected eWirelessAPI api;
    protected eInterfaceHandle hInterface;
    Vector hInterfaces;
    protected String displayString;
    //The window object
    static JFrame aWindow;

    JScrollPane logevents;
JTextArea logging;
JTextField cName;
JButton conButton,startButton,stopButton;
public JMenuBar menuBar = new JMenuBar();   //Window menu bar

public JMenuItem dConnectMenuItem,getActIntMenuItem,getAllIntMenuItem,getConIntMenuItem,getNetCapMenuItem,getNetStatMenuItem,getStatMenuItem,getNetSpecMenuItem,resetStatMenuItem,
                 getSigStrengthMenuItem,getSigQualityMenuItem,shutdownMenuItem,battStrengthMenuItem,resumeMenuItem,suspendMenuItem,disableMenuItem,enableMenuItem,battModeMenuItem,
                 sendMenuItem,getIntNamesMenuItem,getConNamesMenuItem, rfModemStatusMenuItem, rfModemStatisticsMenuItem;
JMenu tcMenu,intMenu,sigMenu,infoMenu,battMenu,nameMenu;
JTextField enName,enBattName,enActIntName;
JPasswordField passwd,changePasswd;
eInterfaceHandle newInterfaceHandle = new eInterfaceHandle(-1);

    public TryWindow()
    {
        super();
        initFrame();
        api = new eWirelessAPI();
        hInterface = new eInterfaceHandle(-1);
        api.addeWirelessAPIListener(this);

        displayString = "";

    }

    public static void main(String[] args){
        TryWindow  tests = new TryWindow();

    }

    //Other Testcases menu items
                     

    public void initFrame()
    {
        aWindow = new JFrame();
        aWindow.setTitle("Java API Test for Wireless Client 5.1.2");
        aWindow.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);

        aWindow.setJMenuBar(menuBar);

        tcMenu = new JMenu("Other Testcases");

        //Construct the "Other Testcases" pull down menu
        dConnectMenuItem = tcMenu.add("Disconnect");
        dConnectMenuItem.addActionListener(this);
        tcMenu.addSeparator();

        intMenu = new JMenu("Interfaces");
        tcMenu.add(intMenu);       //Add the Interfaces sub-menu
        getActIntMenuItem = tcMenu.add("Active Interface");
        getActIntMenuItem.addActionListener(this);
        getAllIntMenuItem = tcMenu.add("All Interface Handles");
        getAllIntMenuItem.addActionListener(this);
        intMenu.add(getActIntMenuItem);
        intMenu.add(getAllIntMenuItem);

        nameMenu = new JMenu("Names");
        tcMenu.add(nameMenu);       //Add the Names sub-menu
        getConNamesMenuItem = tcMenu.add("Configured Connections");
        getConNamesMenuItem.addActionListener(this);
        getIntNamesMenuItem = tcMenu.add("Configured Interfaces");
        getIntNamesMenuItem.addActionListener(this);
        nameMenu.add(getConNamesMenuItem);
        nameMenu.add(getIntNamesMenuItem);



        sigMenu = new JMenu("Signal");
        tcMenu.add(sigMenu);       //Add the Interfaces sub-menu
        getSigStrengthMenuItem = tcMenu.add("Signal Strength");
        getSigStrengthMenuItem.addActionListener(this);
        getSigQualityMenuItem = tcMenu.add("Signal Quality");
        getSigQualityMenuItem.addActionListener(this);
        sigMenu.add(getSigStrengthMenuItem);
        sigMenu.add(getSigQualityMenuItem);


        infoMenu = new JMenu("Network Information");
        tcMenu.add(infoMenu);    //Add the Information sub-menu
  
        getConIntMenuItem = tcMenu.add("Connection Info");
        getConIntMenuItem.addActionListener(this);
        getNetSpecMenuItem = tcMenu.add("Network Specific");
        getNetSpecMenuItem.addActionListener(this);
        getStatMenuItem = tcMenu.add("Statistics");
        getStatMenuItem.addActionListener(this);
        getNetCapMenuItem = tcMenu.add("Network Capabilities");
        getNetCapMenuItem.addActionListener(this);
        getNetStatMenuItem = tcMenu.add("Network Status");
        getNetStatMenuItem.addActionListener(this);
        infoMenu.add(getConIntMenuItem);
        infoMenu.add(getNetSpecMenuItem);
        infoMenu.add(getStatMenuItem);
        infoMenu.add(getNetCapMenuItem);
        infoMenu.add(getNetStatMenuItem);
  
        battMenu = new JMenu("Battery Information");
        tcMenu.add(battMenu);  //Add the Battery Info sub-menu
        battStrengthMenuItem = tcMenu.add("Battery Strength");
        battStrengthMenuItem.addActionListener(this);
        battModeMenuItem = tcMenu.add("Battery Mode");
        battModeMenuItem.addActionListener(this);
        battMenu.add(battStrengthMenuItem);
        battMenu.add(battModeMenuItem);
  

        tcMenu.addSeparator();
        enableMenuItem = tcMenu.add("Enable Transmitter");
        enableMenuItem.addActionListener(this);
        disableMenuItem = tcMenu.add("Disable Transmitter");
        disableMenuItem.addActionListener(this);
        suspendMenuItem = tcMenu.add("Suspend Interface");
        suspendMenuItem.addActionListener(this);
        resumeMenuItem = tcMenu.add("Resume Interface");
        resumeMenuItem.addActionListener(this);
        sendMenuItem = tcMenu.add("Send Redial Message");
        sendMenuItem.addActionListener(this);
        resetStatMenuItem = tcMenu.add("Reset Statistics");
        resetStatMenuItem.addActionListener(this);
        tcMenu.addSeparator();
        
        rfModemStatusMenuItem = tcMenu.add("Get RF Modem Status");
        rfModemStatusMenuItem.addActionListener( this);
        rfModemStatisticsMenuItem = tcMenu.add("Get RF Modem Statistics");
        rfModemStatisticsMenuItem.addActionListener( this);

        tcMenu.addSeparator();
        shutdownMenuItem = tcMenu.add("Shutdown");
        shutdownMenuItem.addActionListener(this);




        menuBar.add(tcMenu);     //Add the "other testcases" menu
        


        Toolkit theKit = aWindow.getToolkit();  //Get the window toolkit
        Dimension wndSize = theKit.getScreenSize(); //Get screen size

        //Set the position to screen center & size to 2/3 screen size
        aWindow.setBounds(wndSize.width/6, wndSize.height/6,  //Position
                          2*wndSize.width/3, 2*wndSize.height/3); //Size
        aWindow.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        aWindow.getContentPane().setLayout(new BorderLayout()); 
        JPanel panel1 = new JPanel();
        panel1.setLayout(new GridLayout(3,0,10,10));

        JLabel uName = new JLabel("Username");
        JLabel pWord = new JLabel("Password");
        JLabel conName = new JLabel("Connection Definition Name");
        enName = new JTextField();
        passwd = new JPasswordField();
        cName = new JTextField();
        cName.addActionListener(this);
        conButton = new JButton("Connect");
        conButton.addActionListener(this);
        startButton = new JButton("Logon");
        startButton.addActionListener(this);
        stopButton = new JButton("Logoff");
        stopButton.addActionListener(this);
        panel1.add(conName);
        panel1.add(uName);
        panel1.add(pWord);
        panel1.add(cName);
        panel1.add(enName);
        panel1.add(passwd);
        panel1.add(conButton);
        panel1.add(startButton);
        panel1.add(stopButton);
     //   panel1.setBackground(Color.pink);
        aWindow.getContentPane().add(panel1, BorderLayout.NORTH);

        JPanel panel2 = new JPanel();
        panel2.setLayout(new GridLayout(2,0));
     //   panel2.setBackground(Color.pink);
        JLabel theEvents = new JLabel("API Events");
        logging = new JTextArea(15,3);
        logging.setText("");
        logevents = new JScrollPane(logging);
        panel2.add(theEvents);
        panel2.add(logevents);
        aWindow.getContentPane().add(panel2, BorderLayout.CENTER);
        JPanel panel3 = new JPanel();
        panel3.setLayout(new GridLayout(2,0,5,5));

        JLabel actInt = new JLabel("Set Active Interface");
        JLabel changePword = new JLabel("Change Password");
        JLabel setBattMode = new JLabel("Set Battery Mode");
        enActIntName = new JTextField();
        enActIntName.addActionListener(this);
        changePasswd = new JPasswordField();
        changePasswd.addActionListener(this);
        enBattName = new JTextField();
        enBattName.addActionListener(this);
        panel3.add(actInt);
        panel3.add(changePword);
        panel3.add(setBattMode);
        panel3.add(enActIntName);
        panel3.add(changePasswd);
        panel3.add(enBattName);

        aWindow.getContentPane().add(panel3, BorderLayout.SOUTH);
        aWindow.addWindowListener(this);
        aWindow.setVisible(true);         //Display the window
    }


    public void actionPerformed(ActionEvent evt)
    {
        //handle events here
        Object src = evt.getSource();
        if (src == conButton) {
            if (api == null)
                { 
                    api = new eWirelessAPI();
                    hInterface = new eInterfaceHandle(-1);
                    api.addeWirelessAPIListener(this);
                }

            int rc = api.eOpenInterface(cName.getText(),"",hInterface);
            logging.append(" rc = eOpenInterface() = "+ rcStrings[rc]+"\r\n");
        }
        if (src == startButton) {
            String thePassword = new String(passwd.getPassword());
            Vector connections = new Vector();
            api.eGetConnectionNames(connections);
            String[] a = new String[connections.size()];
            connections.copyInto(a);
            //this logon assumes the first name returned from eGetConnectionNames is the currentConnection
            int rc = api.eLogon(a[0],enName.getText(),thePassword,"");
            logging.append(" rc = eLogon() = " + rcStrings[rc] + "\r\n");
        }
        if (src == stopButton) {
            int rc = api.eLogoff();
            logging.append(" rc = eLogoff() = " + rcStrings[rc] + "\r\n");
        }
        if (src == enableMenuItem) {
            eInterfaceHandle currentInterface = new eInterfaceHandle(-1);
            api.eGetActiveInterface(currentInterface);
            int rc = api.eEnableTransmitter(currentInterface);
            logging.append(" rc = eEnableTransmitter() = " + rcStrings[rc]
                + "\r\n");
        }
        if (src == disableMenuItem) {
            eInterfaceHandle currentInterface = new eInterfaceHandle(-1);
            api.eGetActiveInterface(currentInterface);
            int rc = api.eDisableTransmitter(currentInterface);
            logging.append(" rc = eDisableTransmitter() = " + rcStrings[rc]
                + "\r\n");
        }
        if (src == resumeMenuItem) {
            eInterfaceHandle currentInterface = new eInterfaceHandle(-1);
            api.eGetActiveInterface(currentInterface);
            int rc = api.eResumeInterface(currentInterface);
            logging.append(" rc = eResumeInterface() = " + rcStrings[rc]
                + "\r\n");
        }
        if (src == sendMenuItem) {
            eInterfaceHandle currentInterface = new eInterfaceHandle(-1);
            api.eGetActiveInterface(currentInterface);
            int rc = api.eSendRedialMessage(currentInterface);
            logging.append(" rc = eSendRedialMessage() = " + rcStrings[rc]
                + "\r\n");
        }
        if (src == resetStatMenuItem) {
            eInterfaceHandle currentInterface = new eInterfaceHandle(-1);
            api.eGetActiveInterface(currentInterface);
            int rc = api.eResetStatistics(currentInterface);
            logging.append( " rc = eResetStatistics() = " + rcStrings[rc]
                + "\r\n");
        }
        if (src == rfModemStatusMenuItem) {
            eInterfaceHandle currentInterface = new eInterfaceHandle(-1);
            api.eGetActiveInterface(currentInterface);
            int rc = api.eGetRFModemStatus(currentInterface);
            logging.append(" rc = eGetRFModemStatus() = " + rcStrings[rc]
                + "\r\n");
        }
        if (src == rfModemStatisticsMenuItem) {
            eInterfaceHandle currentInterface = new eInterfaceHandle(-1);
            api.eGetActiveInterface(currentInterface);
            int rc = api.eGetRFModemStatistics(currentInterface);
            logging.append( " rc = eRFGetModemStatistics() = " + rcStrings[rc]
                + "\r\n");
        }
        if (src == shutdownMenuItem) {
            int rc = api.eShutdown();
            logging.append(" rc = eShutdown() = " + rcStrings[rc]
                + "\r\n");
            try {
                FileOutputStream file = new FileOutputStream("apptrace.txt");
                byte[] log = displayString.getBytes();
                for (int i = 0; i < log.length; i++) {
                    file.write(log[i]);
                }
                file.close();
            } catch (IOException e){
                System.out.println("Error writing log info to file " + e.toString());
            }
            
            // tsr - force clean up 
            api.removeeWirelessAPIListener(this);
            api = null;
            System.gc();

        }
        if (src == getSigQualityMenuItem) {
            eInterfaceHandle currentInterface = new eInterfaceHandle(-1);
            api.eGetActiveInterface(currentInterface);
            int rc = api.eGetSignalQuality(currentInterface);
            logging.append(" rc = eGetSignalQuality() = " + rcStrings[rc]
                + "\r\n");
        }
        if (src == getSigStrengthMenuItem) {
            eInterfaceHandle currentInterface = new eInterfaceHandle(-1);
            api.eGetActiveInterface(currentInterface);
            int rc = api.eGetSignalStrength(currentInterface);
            logging.append(" rc = eGetSignalStrength() = "+ rcStrings[rc]
                + "\r\n");
        }
        if (src == battStrengthMenuItem) {
            eInterfaceHandle currentInterface = new eInterfaceHandle(-1);
            api.eGetActiveInterface(currentInterface);
            int rc = api.eGetBatteryStrength(currentInterface);
            logging.append(" rc = eGetBatteryStrength() = " + rcStrings[rc]
                + "\r\n");
        }
        if (src == battModeMenuItem) {
            eInterfaceHandle currentInterface = new eInterfaceHandle(-1);
            api.eGetActiveInterface(currentInterface);
            int rc = api.eGetBatteryMode(currentInterface);
            logging.append( " rc = eGetBatteryMode() = " + rcStrings[rc]
                + "\r\n");
        }
        if (src == getConIntMenuItem) {
            int rc = api.eGetConnectionInfo();
            logging.append(" rc = eGetConnectionInfo() = " + rcStrings[rc] 
                + "\r\n");
        }
        if (src == getNetSpecMenuItem) {
            eInterfaceHandle currentInterface = new eInterfaceHandle(-1);
            api.eGetActiveInterface(currentInterface);
            int rc = api.eGetNetworkSpecific(currentInterface);
            logging.append( " rc = eGetNetworkSpecific() = " + rcStrings[rc]
                + "\r\n");
        }
        if (src == getStatMenuItem) {
            eInterfaceHandle currentInterface = new eInterfaceHandle(-1);
            api.eGetActiveInterface(currentInterface);
            eStats stats = new eStats(); 
            int rc = api.eGetStatistics(currentInterface, stats);
            logging.append( " rc = eGetStatistics() = " + rcStrings[rc] 
                + "\r\n" + "bytes sent:  " + String.valueOf(stats.getBytes_sent()) 
                + " bytes received:  " + String.valueOf(stats.getBytes_received())
                + " packets sent:  " + String.valueOf(stats.getPkts_sent())
                + " packets received:  " + String.valueOf(stats.getPkts_received())
                + " reserved1:  " + String.valueOf(stats.getReserved1())
                + " connect time:  " + String.valueOf(stats.getConnectTime())
                + "\r\n");
        }
        if (src == enActIntName) {
            api.eOpenInterface(enActIntName.getText(),"",hInterface);
            int rc = api.eSetActiveInterface(hInterface);
            logging.append(" rc = eSetActiveInterface() = " + rcStrings[rc]
                + "\r\n");
        }
        if (src == enBattName) {
            eInterfaceHandle currentInterface = new eInterfaceHandle(-1);
            api.eGetActiveInterface(currentInterface);
            int rc = api.eSetBatteryMode(currentInterface, Integer.parseInt(enBattName.getText()) );
            logging.append(" rc = eSetBatteryMode() = " 
                + rcStrings[rc] + "\r\n");
        }
        if (src == getNetCapMenuItem) {
            eInterfaceHandle currentInterface = new eInterfaceHandle(-1);
            api.eGetActiveInterface(currentInterface);
            int rc = api.eGetNetworkCapabilities(currentInterface);
            logging.append(" rc = eGetNetworkCapabilities() = "
                + rcStrings[rc] + "\r\n");
        }
        if (src == getNetStatMenuItem) {
            eInterfaceHandle currentInterface = new eInterfaceHandle(-1);
            api.eGetActiveInterface(currentInterface);
            int rc = api.eGetNetworkStatus(currentInterface);
            logging.append( " rc = eGetNetworkStatus() = " + rcStrings[rc]
                + "\r\n");
        }
        if (src == changePasswd) {
            String oldPassword = new String(passwd.getPassword());
            String newPassword = new String(changePasswd.getPassword());
            int rc = api.eChangePassword(oldPassword,newPassword);
            logging.append( " rc = eChangePassword("+oldPassword+","+newPassword+") = " + rcStrings[rc] + "\r\n");
        }
        if (src == dConnectMenuItem) {
            //you can only disconnect the active interface
            eInterfaceHandle theActiveOne = new eInterfaceHandle(-1);
            api.eGetActiveInterface(theActiveOne);
            int rc = api.eCloseInterface(theActiveOne);
            logging.append(" rc = eCloseInterface() = " + rcStrings[rc]
                            +"\r\n"); 
        }                                         
        if (src == getConNamesMenuItem) {
            Vector names = new Vector();
            int rc = api.eGetConnectionNames(names);
            String[] a = new String[names.size()];
            names.copyInto(a);
            String conNames = "";
            for (int j =0; j<a.length;j++) {
                  conNames = conNames  + a[j] + " ";
            }
            logging.append( " rc = eGetConnectionNames() = " + rcStrings[rc]
                            + " Connection Names: " + conNames + " Size of Vector:  " + names.size()+"\r\n");
        }
        if (src == getIntNamesMenuItem) {
            Vector connections = new Vector();
            api.eGetConnectionNames(connections);
            String[] a = new String[connections.size()];
            connections.copyInto(a);
            Vector names = new Vector();
            String tmpString = new String("");
            for (int i = 0; i < a.length; i++){
                int rc = api.eGetInterfaceNames(a[i], names);  
                String[] b = new String[names.size()];
                names.copyInto(b);
                String seeNames = " ";
                for (int j = 0; j< b.length; j++)
                   seeNames = seeNames + b[j] + " ";
                tmpString += " rc = eGetInterfaceNames("+a[i]+", ) = " + rcStrings[rc]
                         + " Interface Names:  " + seeNames + " Size of vector:"  
                         + names.size() +"\r\n";
                names.clear();
            }
            logging.append(tmpString);
        }
        if (src == getActIntMenuItem) {
            int rc = api.eGetActiveInterface(hInterface);
            logging.append( " rc = eGetActiveInterface() = " + rcStrings[rc]
                            + " Interface handle:  " + hInterface.getInterfaceHandle() 
                            + "\r\n");
        }
        if (src == suspendMenuItem) {
            eInterfaceHandle currentInterface = new eInterfaceHandle(-1);
            api.eGetActiveInterface(currentInterface);
            int rc = api.eSuspendInterface(currentInterface);
            logging.append( " rc = eSuspendInterface() = " + rcStrings[rc] + "\r\n");
        }
        if (src == getAllIntMenuItem) {
            Vector interfaceHandles = new Vector();
            int rc = api.eGetAllInterfaceHandles(interfaceHandles);
            eInterfaceHandle[] a = new eInterfaceHandle[interfaceHandles.size()];
            interfaceHandles.copyInto(a);
            String handles = "";
            for (int j =0; j<a.length;j++) {
                  handles = handles  + a[j].getInterfaceHandle() + " ";
            }
            logging.append(" rc = eGetAllInterfaceHandles() = " + rcStrings[rc]
                            + " Interface handle: " + handles + "Size of Vector:  " + interfaceHandles.size()+"\r\n");
        }
    }

    public void windowClosing(WindowEvent e)
    {
        aWindow.removeWindowListener(this);
        aWindow.dispose();
        System.exit(0);
    }

    //Listener interface functions we must implement - but don't need
    public void windowOpened(WindowEvent e){
    }
    public void windowClosed(WindowEvent e){
    }
    public void windowIconified(WindowEvent e){
    }
    public void windowDeiconified(WindowEvent e){
    }
    public void windowActivated(WindowEvent e){
    }
    public void windowDeactivated(WindowEvent e){
    }

    // wireless api listener interface
	public void eMsg_AdapterInitialized( eInterfaceHandle theInterfaceHandle, String theInterfaceName)
	{
		String rcString = "event eMsg_AdapterInitialized rcvd for " +
                                  "interface " + theInterfaceName + 
                                  "and InterfaceHandle " + theInterfaceHandle.getInterfaceHandle() +"\r\n";
            logging.append(rcString);
	}
	
	public void eMsg_AdapterResetInProgress( eInterfaceHandle theInterfaceHandle)
	{
		String rcString = "event eMsg_AdapterResetInProgress rcvd" + "\r\n";
            logging.append(rcString);
	}
	
	public void eMsg_BatteryMode( eInterfaceHandle theInterfaceHandle, int theReturnCode, int theBatteryMode)
	{
		String rcString = "event eMsg_BatteryMode rcvd, rc = " + rcStrings[theReturnCode] + ", batterymode = " + String.valueOf( theBatteryMode) +  "\r\n";
            logging.append(rcString);
       }	
	
	public void eMsg_BatteryStrength(eInterfaceHandle theInterfaceHandle, int theReturnCode,	
										int theNormalizedStrength, int theRawStrength)
	{
		String rcString = "event eMsg_BatteryStrength rcvd, rc = " + rcStrings[theReturnCode] + ", normalized strength = " + String.valueOf( theNormalizedStrength) +  ", raw strength = " + String.valueOf( theRawStrength) + "\r\n";
            logging.append(rcString);
        }	
	
	public void eMsg_ChangePassword( int theReturnCode)
	{
		String rcString = "event eMsg_ChangePassword rcvd, rc = " + rcStrings[theReturnCode] +  "\r\n";
            logging.append(rcString);
        }     
	
	public void eMsg_CloseInterface( eInterfaceHandle theInterfaceHandle, int theReturnCode)
	{
		String rcString = "event eMsg_CloseInterface rcvd, rc = " + rcStrings[theReturnCode] +  "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_ConnectionInfo( eInterfaceHandle theInterfaceHandle, int theReturnCode, 
										eConnectionInfo theConnectionInfo)
	{
		String statusStrings[] = { "LOGGED_OFF", "LOGGING_ON", "LOGGED_ON", "LOGGING_OFF" };
		String rcString = "event eMsg_ConnectionInfo rcvd, rc = " + rcStrings[theReturnCode] + ", gw ipaddr = " + theConnectionInfo.getGateway_ipaddr() + ", local ipaddr = " + theConnectionInfo.getLocal_ipaddr() + ", status = " + statusStrings[theConnectionInfo.getStatus()] + "\r\n";
            logging.append(rcString);
	}	
			
	public void eMsg_DisableTransmitter( eInterfaceHandle theInterfaceHandle, int theReturnCode)
	{
		String rcString = "event eMsg_DisableTransmitter rcvd, rc =" + rcStrings[theReturnCode] +  "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_EnableTransmitter( eInterfaceHandle theInterfaceHandle, int theReturnCode)
	{
		String rcString = "event eMsg_EnableTransmitter rcvd, rc = " + rcStrings[theReturnCode] +  "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_HardwareEvent( eInterfaceHandle theInterfaceHandle, int theEventID)
	{
		String rcString = "event eMsg_HardwareEvent rcvd, theEventID = " + String.valueOf( theEventID) +  "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_Logoff( eInterfaceHandle theInterfaceHandle, int theReturnCode)
	{
		String rcString = "event eMsg_Logoff rcvd, rc = " + rcStrings[theReturnCode] +  "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_Logon( eInterfaceHandle theInterfaceHandle, int theReturnCode, String theConnectionConfigName)
	{
		String rcString = "event eMsg_Logon rcvd, rc = " + rcStrings[theReturnCode] +  ", connectionname = " + theConnectionConfigName + "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_NetworkCapabilities( eInterfaceHandle theInterfaceHandle, int theReturnCode, 
											eNetworkCapabilities theNetworkCapabilities)
	{
		String rcString = "event eMsg_NetworkCapabilities rcvd, rc = " + rcStrings[theReturnCode] + ", capabilitiesflag = " + String.valueOf( theNetworkCapabilities.getCapabilities()) + ", averagebps = " + String.valueOf( theNetworkCapabilities.getAverageBPS()) + ", mtusize = " + String.valueOf( theNetworkCapabilities.getMtuSize() + "\r\n");
            logging.append(rcString);
	}	
		
	public void eMsg_NetworkCongested( eInterfaceHandle theInterfaceHandle)
	{
		String rcString = "event eMsg_NetworkCongested rcvd " + "\r\n";
            logging.append(rcString);
	}	
		
	public void eMsg_NetworkInRange( eInterfaceHandle theInterfaceHandle)
	{
		String rcString = "event eMsg_NetworkInRange rcvd " + "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_NetworkMessage( eInterfaceHandle theInterfaceHandle, String theNetworkMessage)
	{
		String rcString = "event eMsg_NetworkMessage rcvd, " + " nwmessage = " + theNetworkMessage + "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_NetworkNoLongerCongested( eInterfaceHandle theInterfaceHandle)
	{
		String rcString = "event eMsg_NetworkNoLongerCongested rcvd " + "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_NetworkOutOfRange( eInterfaceHandle theInterfaceHandle)
	{
		String rcString = "event eMsg_NetworkOutOfRange rcvd " + "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_NetworkSpecific( eInterfaceHandle theInterfaceHandle, int theReturnCode,
									int theNetworkCapabilities,
									String theNetworkSpecificMessage)
	{
		String rcString = "event eMsg_NetworkSpecific rcvd,  rc = " + rcStrings[theReturnCode] +  ", nwcapabilitiesflag = " + String.valueOf( theNetworkCapabilities) + ", thenwspecificmsg = " + theNetworkSpecificMessage + "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_NetworkStatus( eInterfaceHandle theInterfaceHandle, int theReturnCode,
									eNetworkStatus theNetworkStatus)
	{
		String rcString = "event eMsg_NetworkStatus rcvd,  rc = " + rcStrings[theReturnCode] +  ", iscongested = " + String.valueOf( theNetworkStatus.isCongested()) + ", isoutofrange = " + String.valueOf( theNetworkStatus.isOutOfRange()) + ", issuspended = " + String.valueOf( theNetworkStatus.isSuspended()) + ", istransmitter disabled = "  + String.valueOf( theNetworkStatus.isTransmitterDisabled()) + "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_OpenInterface( eInterfaceHandle theInterfaceHandle, int theReturnCode,
						int theNetworkSpecificRC, String theInterfaceName)
	{
                String rcString = "event eMsg_OpenInterface rcvd, Interface Handle = " + theInterfaceHandle.getInterfaceHandle() + ",rc = " + rcStrings[theReturnCode] +  ", Network Specific Return Code = " + String.valueOf( theNetworkSpecificRC) + ", interfacename = " + theInterfaceName + "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_PacketReceived( eInterfaceHandle theInterfaceHandle, int thePacketSize)
	{
		String rcString = "event eMsg_PacketReceived rcvd, packetsize = " + String.valueOf( thePacketSize) +  "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_PacketReceiveFailed( eInterfaceHandle theInterfaceHandle, int theReturnCode)
	{
		String rcString = "event eMsg_PacketReceiveFailed rcvd, rc = " + rcStrings[theReturnCode] + "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_PacketTransmitFailed( eInterfaceHandle theInterfaceHandle, int theReturnCode)
	{
		String rcString = "event eMsg_PacketTransmitFailed rcvd, rc = " + rcStrings[theReturnCode] + "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_PacketTransmitted( eInterfaceHandle theInterfaceHandle, int thePacketSize)
	{
		String rcString = "event eMsg_PacketTransmitted rcvd, packetsize = " + String.valueOf( thePacketSize) +  "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_RedialAttempt( eInterfaceHandle theInterfaceHandle, int theReturnCode)
	{
		String rcString = "event eMsg_RedialAttempt rcvd, rc = " + rcStrings[theReturnCode] + "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_ResumeInterface( eInterfaceHandle theInterfaceHandle, int theReturnCode)
	{
		String rcString = "event eMsg_ResumeInterface rcvd, rc = " + rcStrings[theReturnCode] + "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_SetActiveInterface( eInterfaceHandle theInterfaceHandle, int theReturnCode,
						eInterfaceHandle theNewActiveInterface, eInterfaceHandle theOldActiveInterface)
	{
                hInterface = theInterfaceHandle;
		String rcString = "event eMsg_SetActiveInterface rcvd, rc = " + rcStrings[theReturnCode] + " the Interface Handle:  " + theInterfaceHandle.getInterfaceHandle() + ", new Active Interface: " + theNewActiveInterface.getInterfaceHandle() + ", old Active Interface: " + theOldActiveInterface.getInterfaceHandle() +"\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_Shutdown( )
	{
		String rcString = "event eMsg_Shutdown rcvd " + "\r\n";
            logging.append(rcString);
}	
	
	public void eMsg_SignalQuality( eInterfaceHandle theInterfaceHandle, int theReturnCode,
							int theNormalizedQuality, int theRawQuality)
	{
		String rcString = "event eMsg_SignalQuality rcvd, rc = " + rcStrings[theReturnCode] + ", normalized = " + String.valueOf( theNormalizedQuality) +  ", raw = " + String.valueOf( theRawQuality) + "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_SignalStrength ( eInterfaceHandle theInterfaceHandle, int theReturnCode,
							int theNormalizedStrength, int theRawStrength)
	{
		String rcString = "event eMsg_SignalStrength rcvd, rc = " + rcStrings[theReturnCode] + ", normalized = " + String.valueOf( theNormalizedStrength) +  ", raw = " + String.valueOf( theRawStrength) + "\r\n";
            logging.append(rcString);
	}	
	
	public void eMsg_SuspendInterface( eInterfaceHandle theInterfaceHandle, int theReturnCode)
	{
		String rcString = "event eMsg_SuspendInterface rcvd, rc = " + rcStrings[theReturnCode] + "\r\n";
            logging.append(rcString);
	}        

        public void eMsg_Logon(int theReturnCode, String theConnectionConfigName)
        {
            String rcString = "event eMsg_Logon rcvd, rc = " + rcStrings[theReturnCode] + "\r\n";
            logging.append(rcString);
        }

        public void eMsg_Logoff(int theReturnCode)
        {
            String rcString = "event eMsg_Logoff rcvd, rc = " + rcStrings[theReturnCode] + "\r\n";
            logging.append(rcString);
        }

        public void eMsg_PacketTransmitFailed(eInterfaceHandle hInterface, int one, int two)
        {
            logging.append("eMsg_PacketTransmitFailed"  + "\r\n");
        }

	public void eMsg_NotifyTray(eInterfaceHandle hInterface, int one)
        {
            logging.append("eMsg_NotifyTray" + "\r\n");
        }

	public void eMsg_ConnectionInfo(int one, eConnectionInfo two)
        {
            logging.append("eMsg_ConnectionInfo" + "\r\n");
        }
	
	public void eMsg_RadiusAuthentication(eInterfaceHandle hInterface, int one)
	{
	    logging.append("eMsg_RadiusAuthentication" + "\r\n");
	}

	public void eMsg_PacketReceiveFailed(eInterfaceHandle hInterface, int one, int two)
	{
	    logging.append("eMsg_PacketReceiveFailed" + "\r\n");
	}

	public void eMsg_NetworkAdapters( eInterfaceHandle theInterfaceHandle, int theReturnCode,
									eNetworkAdapters theNetworkAdapters)
	{
		String rcString = "event eMsg_NetworkAdapters rcvd,  rc = " + rcStrings[theReturnCode] + " ActiveAdapter is " + theNetworkAdapters.getAdapterName(theNetworkAdapters.getIndexOfActive()) + "\r\n";
        logging.append(rcString);
	}
	public void eMsg_RFModemStatus( eInterfaceHandle theInterfaceHandle, int theReturnCode, eRFModemStatus theRFModemStatus)
    {
        String rcString = "event eMsg_RFModemStatus rcvd,  rc = " + rcStrings[theReturnCode]  + "\r\n";
        rcString = rcString + "      range = " + theRFModemStatus.Range() + ", " + ((theRFModemStatus.Range() == theRFModemStatus.eIN_RANGE) ? "eIN_RANGE" : "eOUT_OF_RANGE") + "\r\n";
        rcString = rcString + "      transmitter = " + theRFModemStatus.Transmitter() + ", " + ((theRFModemStatus.Transmitter() == theRFModemStatus.eDISABLED) ? "eDISABLED" : "eENABLED") + "\r\n";
        rcString = rcString + "      receiver = " + theRFModemStatus.Receiver() + ", " + ((theRFModemStatus.Receiver() == theRFModemStatus.eDISABLED) ? "eDISABLED" : "eENABLED") + "\r\n";
        rcString = rcString + "      antenna = " + theRFModemStatus.Antenna() + "\r\n";
        rcString = rcString + "      flowControl = " + theRFModemStatus.FlowControl() + ", " + ((theRFModemStatus.FlowControl() == theRFModemStatus.eNONE) ? "eNONE" : ((theRFModemStatus.FlowControl() == theRFModemStatus.eXONXOFF) ? "eXONXOFF" : "eRTSCTS")) + "\r\n";
        rcString = rcString + "      receivemode = " + theRFModemStatus.ReceiveMode() + ", " + ((theRFModemStatus.ReceiveMode() == theRFModemStatus.eCONFIRMED) ? "eCONFIRMED" : "eUNCONFIRMED") + "\r\n";
        rcString = rcString + "      basestationid = " + theRFModemStatus.BaseStationID() + "\r\n";
        rcString = rcString + "      rxquality = " + theRFModemStatus.RxQuality() + "\r\n";
        rcString = rcString + "      modemstate = " + theRFModemStatus.ModemState() + "\r\n";
        rcString = rcString + "      queuetobesent = " + theRFModemStatus.QueuedToBeSent() + "\r\n";
        rcString = rcString + "      queuetobereceived = " + theRFModemStatus.QueuedToBeReceived() + "\r\n";
        rcString = rcString + "      radiochannel = " + theRFModemStatus.RadioChannel() + "\r\n";
        logging.append( rcString);
	}
	public void eMsg_RFModemStatistics( eInterfaceHandle theInterfaceHandle, int theReturnCode, eRFModemStatistics theRFModemStatistics)
    {
        String rcString = "event eMsg_RFModemStatistics rcvd,  rc = " + rcStrings[theReturnCode]  + "\r\n";
        logging.append( rcString);
	}
}
